import sys, sgmllib, MySQLdb, urllib
from _mysql_exceptions import IntegrityError
from time import strftime
from rsconfig import RSConfig

class PlubePostParser(sgmllib.SGMLParser):
    "A simple parser class."

    def parse(self, link, debug):
        "Parse the given string link."
        
        f = urllib.urlopen(link)
        s = f.read()
        self.links = []
        self.debug = debug

        self.feed(s)
        self.close()

    def __init__(self, verbose=0):
        "Initialise an object, passing 'verbose' to the superclass."

        self.links = []
        
        sgmllib.SGMLParser.__init__(self, verbose)

    def handle_data(self, data):
        "Handle the textual 'data'."

        if data.find("http://rapidshare.com/files/") >= 0:
            self.links.append(data.strip())
            if self.debug:
                print "  - " + data.strip()

    def get_links(self):
        "Return the list of hyperlinks."

        return self.links


class PlubeAutoRobot(sgmllib.SGMLParser):
    "A simple parser class."

    def __init__(self, verbose=0):
        "Initialise an object, passing 'verbose' to the superclass."

        self.debug = 0
        self.store = 1
        
        self.in_title = 0
        self.title = ""
        self.title_link = ""
        self.date = strftime("%Y-%m-%d %H:%M:%S")
        self.tuples = []
        
        self.postParser = PlubePostParser()
        self.config = RSConfig()

        sgmllib.SGMLParser.__init__(self, verbose)

    def parse(self, section):
        "Parse the given string link."
        
        f = urllib.urlopen("http://www.plube.com/category/" + section + "/")
        s = f.read()

        self.feed(s)
        self.close()

    def commit(self):
        # are we in entry div?

        if self.store:
            if self.debug:
                print "Commiting records to database"
            try:
                db = MySQLdb.connect(host=self.config.mysql_host, user=self.config.mysql_user, passwd=self.config.mysql_password, db=self.config.mysql_database)
                db.autocommit(1)
                cursor = db.cursor()            
                cursor.executemany("""INSERT INTO jobs (link, comment, user, ip, category_id, state, inserted) VALUES (%s, %s, %s, %s, %s, %s, %s) ON DUPLICATE KEY UPDATE link=link;""", self.tuples)    
                db.commit()
                cursor.close()
                db.close
                if self.debug:
                    print "Commited"
            except IntegrityError, (e,s):
                if self.debug:
                    print "None inserted - already exists"
            except:
                print "General database error "
        else:
            print "Saving disabled"
            
        self.tuples = []
                
    def start_a(self, attributes):
        "Process a hyperlink and its 'attributes'."

        for name, value in attributes:
            if name == "rel" and value == "bookmark":
                self.in_title = 1
                
        if self.in_title:
            self.title = ""
            self.date = strftime("%Y-%m-%d %H:%M:%S")
            for name, value in attributes:
                if name == "href":
                    self.title_href = value
                    break
                
    def end_a(self):
        "Record the end of a hyperlink."

        # process the content
        if self.in_title:
            self.in_title = 0
            
            if self.debug:
                print "Processing " + self.title
                print "  " + self.title_href
            
            self.postParser.parse(self.title_href, self.debug)
            for link in self.postParser.get_links():
                self.tuples += [(link,self.title,'plube_robot','localhost',2,0,self.date)]
                
            self.commit()
                            
    def handle_data(self, data):
        "Handle the textual 'data'."

        if self.in_title:
            self.title += data

# Try and process the page.
plubeAutoRobot = PlubeAutoRobot()
plubeAutoRobot.parse("tv-shows")
